/**
 * Official Type definitions for LemonadeJS plugins
 * https://lemonadejs.net
 * Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
 */

declare function Contextmenu(el: HTMLElement, options?: Contextmenu.Options): Contextmenu.Instance;

declare namespace Contextmenu {
    interface Item {
        submenu?: Item[];
        title?: string;
        type: 'line' | undefined;
        onclick?: (e: MouseEvent, element: HTMLElement) => void;
        icon?: string;
        render?: (e: MouseEvent, element: HTMLElement) => void;
        /** onopen event */
        onopen?: (self: object) => void;
        /** onclose event */
        onclose?: (self: object) => void;
    }

    interface Options {
        /** Modal is closed */
        options?: Item[];
    }

    interface Instance {
        options: boolean;
        open: (options: Options, x: number, y: number, e: MouseEvent) => void;
        close: () => void;
    }
}

export default Contextmenu;